package com.example.libtest;

import java.io.UnsupportedEncodingException;


import com.bw.spdev.IccReader;
import com.bw.spdev.RspCode;
import com.bw.spdev.SysCmd;
import com.helper.BCDHelper;


import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.AdapterView.OnItemSelectedListener;

public class IccDemo extends Activity 
{
	private   String[] mSlot;  
	private TextView view,title,selSlot ;  
	private Spinner spinner;  
	private ArrayAdapter<String> adapter;  
	int slot;

	Button btnIccDemoAtr,btnIccDemoApduSend,btnEject;
	
	ReadThread rth;
	int notgoflag;
	
	EditText textATR,textAPDU;
	BCDHelper bcd;
	ScrollView scroview;
	boolean CardConnected ;
	 
	 private class ReadThread extends Thread 
	 {
			private boolean mStopRunning = false;
			//private AlertDialog show;
			public void stopRunning() {
	            mStopRunning = true;
	        }
			public void startRunning(){
				mStopRunning = false;
			}
			public void run(){
				super.run();
				Log.e("card", "Begin run read thread...");
				while (!mStopRunning) 
				{		        	 
		        	 Log.e(null, "before thread");
		        	 int loop=60;
		        	 int flag=0; 

		        	 while(true)
		        	 {
		        		if(mStopRunning==true)
		        			 break;
		        		
		        		handler1.sendEmptyMessage(9);
			        	
		        		if(PosUtils.icc.Detect()==RspCode.RSPOK)
		        		{	
		        			flag=1;
		        			break;
		        		}
		        	
		        		if(loop<=0)
		        		{
		        			break;
		        		}
		        		loop=loop-1;
		        		
		        		try 
		        		{
		                    Thread.currentThread().sleep(200);
		                } 
		        		catch (InterruptedException e) 
		        		{
		                    e.printStackTrace();
		                }
		                
		        	 }

		        	 mStopRunning = true;
		        	 handler1.sendEmptyMessage(flag);
		        	 
		        	 rth.interrupt();
		        	 rth=null;
		        	 
		         }
			}
		};
	 
	 
	
	 @Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		 if(rth != null)
			 rth.stopRunning();
		super.onDestroy();
	}

	private Handler handler1 =new Handler()
	 {
		   @Override
		   //当有消息发送出来的时候就执行Handler的这个方法
		   public void handleMessage(Message msg)
		   {
		      super.handleMessage(msg);
		      //只要执行到这里就关闭对话框
		      //pd.dismiss();
		      if(msg.what==9)
		      {
		    	  view.append(getString(R.string.ic_PlsInsertIc).toString()+"\n");
		            
		    	  view.scrollTo(0, view.getHeight());
		    	
		      }
		      if(msg.what==0)
		      {
		    	 
		    	  view.append("Dont dectet the Icc inserted,Exit with Timeout \n");
		    	  view.scrollTo(0, view.getHeight());  
		    	 
		      }
		      if(msg.what==1)
		      {
		    	 
		    	  byte atr[] = new byte[100];
		    	  view.append(getString(R.string.ic_DetectedIcc).toString()+"\n");
		           
		    	  view.scrollTo(0, view.getHeight());
		    	  
		    	  if(PosUtils.icc.Reset()!=RspCode.RSPOK)
		    	  {
		    		  Log.e(null,"rest card err");
		    		  view.append(getString(R.string.ic_ResetFail).toString()+"\n");
			    	  view.scrollTo(0, view.getHeight());
		    		  return;
		    	  }
		    	  
		    	  int len = PosUtils.icc.GetAtr(atr);
		    	  if(len<0)
		    	  {
		    		  Log.e(null, "Get Atr Err&&&&&&&&&");
		    		 
		    		  view.append("Failure to obtain the card ATR! \n");
			    	  view.scrollTo(0, view.getHeight());
		    	  }
		    	  String str2;
		    	  try 
		    	  {
					str2 = new String(atr, "ISO-8859-1");
					view.append("ATR: "+str2+" \n");
			    	view.scrollTo(0, view.getHeight());
					
					CardConnected = true;
		    	  } 
		    	  catch (UnsupportedEncodingException e) 
		    	  {
						// TODO Auto-generated catch block
						e.printStackTrace();
		    	  }
  
		      }
		      scroll2Bottom(scroview, view);
		   }
		};
	
		
		@Override
		public boolean onKeyDown(int keyCode, KeyEvent event) 
		{
			Log.e(null,"enter the keydown process");
		    if(keyCode == KeyEvent.KEYCODE_BACK) 
		    { //监控/拦截/屏蔽返回键
		    	if(rth!=null)
		    		rth.stopRunning();	
		    	
		    	IccDemo.this.finish();
		    	
		    } 
		    else if(keyCode == KeyEvent.KEYCODE_MENU) 
		    {
		        //监控/拦截菜单键
		    } 
		    else if(keyCode == KeyEvent.KEYCODE_HOME) 
		    {
		        //由于Home键为系统键，此处不能捕获，需要重写onAttachedToWindow()
		    }
		    return super.onKeyDown(keyCode, event);
		}

	public void onCreate(Bundle savedInstanceState) 
	{
		Log.e(null,"enter the Icc demo activity");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_icc);
		mSlot = new String [2];
		mSlot[0] = getString(R.string.ic_UserCard).toString();
		mSlot[1] = getString(R.string.ic_PsamCard).toString();
		CardConnected = false;
		title = (TextView)findViewById(R.id.icTitle);
		title.setText(R.string.ic_Button);
		selSlot= (TextView)findViewById(R.id.textView_icselSlot);
		selSlot.setText(R.string.ic_SlectSlot);
		SpinnerSetUp();
		
		bcd =new BCDHelper ();
		
		//textATR = (EditText)findViewById(R.id.e);
		textAPDU = (EditText)findViewById(R.id.icApdu);
		
		textAPDU.setText("00A40400023F00");
		
		view = (TextView)findViewById(R.id.iccMsg);
		scroview = (ScrollView)findViewById(R.id.scrollView_icc);
		
		
		btnIccDemoAtr= (Button)findViewById(R.id.btnIcReset);
		btnIccDemoApduSend = (Button)findViewById(R.id.btnIcSendApdu);
		btnEject= (Button)findViewById(R.id.btnIcEject);
		
		btnIccDemoAtr.setText(R.string.ic_Reset);
		btnIccDemoApduSend.setText(R.string.ic_ApduSend);
		btnEject.setText(R.string.ic_Eject);
		
		ModuleButton listener = new ModuleButton();
		btnIccDemoAtr.setOnClickListener(listener);
		btnIccDemoApduSend.setOnClickListener(listener);
		btnEject.setOnClickListener(listener);
	          
	} 
	
	class ModuleButton implements OnClickListener
	{
		int ret ;
		public void onClick(View v)
		{
			switch(v.getId())
			{
			
			case R.id.btnIcEject:
				ret = PosUtils.icc.Eject();
				if(ret == RspCode.RSPOK)
					view.append(getString(R.string.ic_EjectOk).toString()+"\n");
				else
					view.append(getString(R.string.ic_EjectFail).toString()+"\n");
					
					
				break;
			case R.id.btnIcReset:
				
				view.append(getString(R.string.ic_PlsInsertIc).toString()+"\n");
				view.scrollTo(0, view.getHeight());
				if(rth ==null)
				{
					rth = new ReadThread();
					rth.start();
				}
				
				break;
			case R.id.btnIcSendApdu:
				String str=textAPDU.getText().toString();
				
				if(str.length()%2!=0||str.length()<8)
				{
					view.append(getString(R.string.ic_ApduLenErr).toString()+"\n");
					view.scrollTo(0, view.getHeight());
					break;
				}	
				
				byte []pCmd = new byte[300];
				byte []pRsp = new byte[300];
				byte []pSW = new byte[3];
				
				view.append(str+"\n");
				pCmd = bcd.StrToBCD(str);
				ret =PosUtils.icc.ApduTransmit(pCmd, str.length()/2, pRsp, pSW);
				if(ret==RspCode.RSPERR)
				{
					view.append(getString(R.string.ic_ApduErr).toString()+"\n");
					
					
				}	
				else
				{
					if(ret > 0)
					{
						String strrsp = bcd.bcdToString(pRsp, 0, ret);
						view.append(strrsp+"\n");
						Log.e("iccdemo",strrsp);
						
					}
					String strsw =  bcd.bcdToString(pSW, 0, 4);
					view.append(strsw+"\n");		
					Log.e("iccdemo",strsw);
				}
				view.scrollTo(0, view.getHeight());

				break;
			}
			   scroll2Bottom(scroview, view);
			

		}
	}
	
	
	void SpinnerSetUp()
	{
		spinner = (Spinner) findViewById(R.id.spinner_icslot);  

        //将可选内容与ArrayAdapter连接起来  
        adapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mSlot);  
          
        //设置下拉列表的风格  
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);  
          
        //将adapter 添加到spinner中  
        spinner.setAdapter(adapter);  
          
        //添加事件Spinner事件监听    
        spinner.setOnItemSelectedListener(new SpinnerSelectedListener());  
          
        //设置默认值  
        spinner.setVisibility(View.VISIBLE);
	}
		      
    //使用数组形式操作  
    class SpinnerSelectedListener implements OnItemSelectedListener
    {  
        public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2,  
                long arg3) 
        {  
            slot = arg2;
            Log.e("iccdemo","选择卡槽 "+mSlot[arg2]);
            int ret = PosUtils.icc.SelectSlot((byte)slot);
            //view.setMovementMethod(new ScrollingMovementMethod());
            if(ret !=0)
            	view.append(getString(R.string.ic_SlectSlot).toString()+mSlot[arg2]+getString(R.string.ic_Fail).toString()+"\n");
            else
            	view.append(getString(R.string.ic_SlectSlot).toString()+mSlot[arg2]+getString(R.string.ic_Ok).toString()+"\n");
            
            
            view.scrollTo(0, view.getHeight());
            
            scroll2Bottom(scroview, view);
            
            if(CardConnected = true)
            {
            	PosUtils.icc.Eject();
            	CardConnected = false;
            	
            }
            
            //textATR.setText("");

            	
        }  
  
        public void onNothingSelected(AdapterView<?> arg0)
        {  
        	
        }  
    }  
    
    public static void scroll2Bottom(final ScrollView scroll, final View inner) {  
        Handler handler = new Handler();  
        handler.post(new Runnable() {  
  
            @Override  
            public void run() {  
                // TODO Auto-generated method stub   
                if (scroll == null || inner == null) {  
                    return;  
                }  
                // 内层高度超过外层   
                int offset = inner.getMeasuredHeight()  
                        - scroll.getMeasuredHeight();  
                if (offset < 0) {  
                    offset = 0;  
                }  
                scroll.scrollTo(0, offset);  
            }  
        });  
    } 

}
