package com.example.libtest;


import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import org.apache.http.util.EncodingUtils;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Rect;
import android.os.Bundle;
import android.os.Environment;
import android.os.Looper;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

import com.bw.spdev.PosDevCallBackController;
import com.bw.spdev.RspCode;
import com.helper.FileService;
import com.odm.misc.MiscDevice;
import com.odm.misc.MiscUtil;

@SuppressLint({ "NewApi", "SdCardPath" })
public class MainActivity extends Activity {

	String LOGID = "PRINER";
	private BTN_Click btnClick = new BTN_Click(); 
	byte printData[];
	int  printlen;
	//private int  request_code=0;
	PrintThread rth = null;
	Button btnPrinter;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		this.setTitle(R.string.main_title);
		
		Button btnMagcard = (Button) findViewById(R.id.btnMagcard);
		//Button btnKeypad  = (Button) findViewById(R.id.btnKeypad);
		Button btnIcc  = (Button) findViewById(R.id.btnIccDemo);
		Button btnPinPed = (Button) findViewById(R.id.btnPinPed);
		btnPrinter = (Button) findViewById(R.id.btnPrinterDemo);
		
		
		 String s = "6214830219694766D24112200408700990981F";
         if(s.charAt(s.length()-1)=='F')
        	 s = s.substring(0,s.length()-1);
		
		btnMagcard.setText(R.string.mag_Button);
		btnIcc.setText(R.string.ic_Button);
		btnPinPed.setText(R.string.ped_button);
		btnPrinter.setText(R.string.printer_btnPrinter);
		
		btnPrinter.setOnClickListener(btnClick);
		btnMagcard.setOnClickListener(btnClick);
		//btnKeypad.setOnClickListener(btnClick);	
		btnIcc.setOnClickListener(btnClick);	
		btnPinPed.setOnClickListener(btnClick);
		
		Button btnPicc = (Button) findViewById(R.id.btnPiccDemo);
		btnPicc.setOnClickListener(btnClick);
		btnPicc.setText(R.string.picc_Button);
		
		PowerOnDevice();
		PosUtils.InitDev();
		PosUtils.sys.SetCmdSendMaxWT(1000);
		PosUtils.sys.SetRspRecvMaxWT(1000);
		MyDialog dialog = new MyDialog(MainActivity.this,"","Starting,pls wait...");
		dialog.showDialog();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	protected void dialog(String errMsg) 
	{
		  AlertDialog.Builder builder = new Builder(MainActivity.this);
		  builder.setMessage(errMsg);
		  builder.setTitle("错误");
		  builder.setPositiveButton("确定", new android.content.DialogInterface.OnClickListener() {
		   @Override
		   public void onClick(DialogInterface dialog, int which) 
		   {
			   dialog.dismiss();
		    }
		  });
		  builder.create().show();
		 
	}
	
	class BTN_Click implements OnClickListener {
		@Override
		public void onClick(View v) {
			//Intent it = getIntent();
			int loop=512;
			Intent intent;
			
			switch(v.getId())
			{
			case R.id.btnPinPed:
				intent = new Intent(getApplicationContext(), PinPedDemo.class);		    	 
				startActivityForResult(intent,0);
				break;
				
			case R.id.btnPrinterDemo:
				btnPrinter.setEnabled(false);
				
				PosUtils.sp.SpDevSetAppContext(MainActivity.this);
				rth = new PrintThread();
				rth.startRunning();
				rth.start();				
				break;
				
			case R.id.btnPiccDemo:
				Intent intentPicc = new Intent();  
				intentPicc.putExtra("testIntent", "123");     
				intentPicc.setClass(MainActivity.this, PiccDemo.class);  
				Log.e(null, "enter Picc test");
	            MainActivity.this.startActivity(intentPicc); 
				break;
				
			case R.id.btnMagcard:
				Intent intentMagcard = new Intent();  
				intentMagcard.putExtra("testIntent", "123");     
				intentMagcard.setClass(MainActivity.this, SwipeCard.class);  
				Log.e(null, "enter magcard test");
	            MainActivity.this.startActivity(intentMagcard); 
				break;
			
			
				
			case R.id.btnIccDemo:				
				Intent intentIccDemo = new Intent();
				intentIccDemo.putExtra("testIntent", "123");     
				intentIccDemo.setClass(MainActivity.this, IccDemo.class);
				Log.e(null, "enter Icc test");
	            MainActivity.this.startActivity(intentIccDemo);
				break;
				
			default:
				break;
			}
		}		
	}
	
	
	 public byte[] Bitmap2Bytes(Bitmap bm) 
	 {
          ByteArrayOutputStream baos = new ByteArrayOutputStream();
          bm.compress(Bitmap.CompressFormat.PNG, 100, baos);
          return baos.toByteArray();
     }
	
	 
	 
	 /**
		 * һ��ȡ�ļ�����
		 * @param filename �ļ�����
		 * @param content �ļ�����
		 * @throws Exception
		 */
		public String readFile(String filename) throws Exception {
			FileInputStream fis = this.openFileInput(filename);
			
			byte[] buffer = new byte[1024*1024];
			int len = 0;
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			while((len = fis.read(buffer)) != -1) {
				baos.write(buffer, 0, len);
			}
			byte[] data = baos.toByteArray(); //�õ��ļ��Ķ���������
			baos.close();
			fis.close();
			return new String(data);
		}

		 private class PrintThread extends Thread 
		 {
				private boolean mStopRunning = false;
				//private AlertDialog show;
				public void stopRunning() {
		            mStopRunning = true;
		        }
				public void startRunning(){
					mStopRunning = false;
				}
				public void run()
				{
					Looper.prepare();
					super.run();
					
					toPrint();
					//or 
					//toPrintBmp();
					
					Looper.loop();
					rth = null;
				}
			};
			
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		// TODO Auto-generated method stub
		if (keyCode == KeyEvent.KEYCODE_BACK)
		{ // ���/����/���η��ؼ�
			PosUtils.sp.SpDevRelease();
			PowerOffDevice();
		}
		return super.onKeyDown(keyCode, event);
	}

	private String getDateTimeStr(){
		SimpleDateFormat sDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");       
		String datetime = sDateFormat.format(new java.util.Date());
		return datetime;
	}
	
	void toPrint() {
		final Calendar c = Calendar.getInstance();
		int mYear = c.get(Calendar.YEAR);
		int mMonth = c.get(Calendar.MONTH);
		int mDay = c.get(Calendar.DAY_OF_MONTH);
		int mHour = c.get(Calendar.HOUR_OF_DAY);
		int mMinute = c.get(Calendar.MINUTE);
		int mSec = c.get(Calendar.SECOND);

		PosUtils.sp.SpDevSetAppContext(getApplicationContext());
		// init,set the callbak
		PosUtils.printer.Init(new DeviceResponseHandlerImpl(),
				getApplicationContext());
		PosUtils.printer.ClearPrintData();// ��մ�ӡ����
		PosUtils.printer.SetStep(1000);// ���ò���
		PosUtils.printer.SetPrinterPara((short) 1250);// ���ô�ӡ�Ҷ�

		StringBuilder time = (new StringBuilder()
				.append((mHour < 10) ? "0" + mHour : mHour).append(":")
				.append((mMinute < 10) ? "0" + mMinute : mMinute).append(":")
				.append((mSec < 10) ? "0" + mSec : mSec));
		String sTime = time.toString();

		StringBuilder data = (new StringBuilder()
				.append((mMonth + 1) < 10 ? "0" + (mMonth + 1) : (mMonth + 1))
				.append("/").append((mDay < 10) ? "0" + mDay : mDay)
				.append("/").append(mYear));
		String sData = data.toString();
		PosUtils.printer.SetProperty(0);//是否粗体
		PosUtils.printer.SetFontSize(24);
		PosUtils.printer.AddString(getDateTimeStr());		
		PosUtils.printer.AddString("\n");
		PosUtils.printer.AddString("12345abcd.,/;'][\n");
		
		PosUtils.printer.SetFontPath("simsun.ttc");
		PosUtils.printer.AddString("中文测试数据打印一行");
		PosUtils.printer.AddString("\r\n");
		PosUtils.printer.AddString("中文测试数据打印一行");
		PosUtils.printer.AddString("\r\n ");
		PosUtils.printer.AddString("\r\n ");
		PosUtils.printer.AddString("\r\n ");
		PosUtils.printer.Print();
	}
	
	class DeviceResponseHandlerImpl extends PosDevCallBackController
	{
		@Override
		public int onPrinterPrint(int status) 
		{
			runOnUiThread(new Runnable() {
                @Override
                public void run() {
                	btnPrinter.setEnabled(true);
                }
            });
			
			
			switch(status)
			{
			case RspCode.RSPOK:
				Log.e(null,"print finish");
				break;
			case RspCode.RET_PRINTER_ERR_COMERR:
				Log.e(null,"RET_PRINTER_ERR_COMERR");
				break;
			case RspCode.RET_PRINTER_ERR_BMPLOST:
				Log.e(null,"RET_PRINTER_ERR_BMPLOST");
				break;
			case RspCode.RET_PRINTER_ERR_NOPAPER:
				Log.e(null,"RET_PRINTER_ERR_NOPAPER");
				break;
			case RspCode.RET_PRINTER_ERR_HT:
				Log.e(null,"RET_PRINTER_ERR_HT");
				break;
			default:
			case RspCode.RET_PRINTER_ERR_OTHER:
				Log.e(null,"RET_PRINTER_ERR_OTHER");
				break;
			}
			return 0;
		}
	}
	
	
	void toPrintBmp() 
	{
		 PosUtils.sp.SpDevSetAppContext(getApplicationContext());
         //set the callback
         PosUtils.printer.Init(new DeviceResponseHandlerImpl(),getApplicationContext());
         PosUtils.printer.ClearPrintData();//clean the data
         PosUtils.printer.SetStep(1000);//set the step
         PosUtils.printer.SetPrinterPara((short) 1250);//set the gray
        
         //hunter1
         
//         FileService fp = new FileService();
//         fp.open(Environment.getExternalStorageDirectory().getPath()+"/test.bmp", "rw");
//         int size = (int) fp.size();
//         
//         Log.d("ToPrintBmp", Environment.getExternalStorageDirectory().getPath()+"/test.bmp");
//         Log.e(null,"file size:"+size);
//         
//         byte ptr[] = fp.read(size);
//         fp.close();
         
         byte [] ptr1 = readFromRaw();         
         PosUtils.printer.AddBmpData(ptr1, ptr1.length, 40, 0);
         PosUtils.printer.Print();
         //PosUtils.printer.PrintBmp(Environment.getExternalStorageDirectory().getPath()+"/ic_launcher.bmp", 40,0 );
	
	}

	public byte[] readFromRaw()
	{
		String res = ""; 
		try{ 
		 
		    //�õ���Դ�е�Raw������
		    InputStream in = getResources().openRawResource(R.raw.test); 

		    //�õ����ݵĴ�С
		    int length = in.available();       

		    byte [] buffer = new byte[length];        

		    //��ȡ����
		    in.read(buffer);         

		   
		    //�ر�    
		    in.close();  
		    return buffer;

		   }catch(Exception e){ 
		      e.printStackTrace();         
		   }
		return null;
	}
	
	
	private  Bitmap toGrayscale(Bitmap bmpOriginal) {  
	        int width, height;  
	        height = bmpOriginal.getHeight();  
	        width = bmpOriginal.getWidth();      
	      
	        Bitmap bmpGrayscale = Bitmap.createBitmap(width, height, Bitmap.Config.RGB_565);  
	        Canvas c = new Canvas(bmpGrayscale);  
	        Paint paint = new Paint();  
	        ColorMatrix cm = new ColorMatrix();  
	        cm.setSaturation(0);     
	        ColorMatrixColorFilter f = new ColorMatrixColorFilter(cm);  
	        paint.setColorFilter(f);     
	        c.drawBitmap(bmpOriginal, 0, 0, paint);     
	        return bmpGrayscale;  
	    }  

	private Bitmap takeScreenShot() {  
	 
	        View view = getWindow().getDecorView();  
	        view.setDrawingCacheEnabled(true);  
	        view.buildDrawingCache();  
	        Bitmap obtainBitmap = view.getDrawingCache();  

	        Rect frame = new Rect();  
	        getWindow().getDecorView().getWindowVisibleDisplayFrame(frame);  
	        int statusBarHeight = frame.top;  
	          
	        int width = getWindowManager().getDefaultDisplay().getWidth();  
	        int height = getWindowManager().getDefaultDisplay().getHeight();  
	       
	        Matrix matrix = new Matrix();  
	        matrix.postScale(1.0f, 1.0f);  

	        Bitmap bitmap = Bitmap.createBitmap(obtainBitmap, 0, statusBarHeight, width, height  
	                - statusBarHeight, matrix, true);  
	          
	        view.destroyDrawingCache();  
	        view.setDrawingCacheEnabled(false);  
	          
	        return bitmap;  
	    }   

		void ReadFile()
		{
			String fileName = "done_20140117154757.bmp"; //�ļ�����

			String res=""; 

			try{ 

			   InputStream in = getResources().getAssets().open(fileName);

			   // \Test\assets\yan.txt�������������ļ�����

			   int length = in.available();         
			   printlen = length;
			printData = new byte[length];        

			in.read(printData);            

			res = EncodingUtils.getString(printData, "UTF-8"); 
			Log.e(null,res);

			}catch(Exception e){ 

			      e.printStackTrace();         

			   }

		}

	    /** 
	     * save pic to the special path
	     *  
	     * @param b 
	     * @param strFileName 
	     */  
	    private static void savePic(Bitmap b, String strFileName) {  
	      
	        FileOutputStream fos = null;  
	        try {  
	            fos = new FileOutputStream(strFileName);  
	            if (null != fos) {  
	                b.compress(Bitmap.CompressFormat.PNG, 90, fos);  
	                fos.flush();  
	                fos.close();  
	            }  
	        } catch (FileNotFoundException e) {  
	            e.printStackTrace();  
	        } catch (IOException e) {  
	            e.printStackTrace();  
	        }  
	    }  
	    
	   void PowerOffDevice()
	   {
		   Class<?> c;
	        
	        String postty = null;
	        try {
	        	  
	        	//Log.e(null,"1");
	            c  = Class.forName("android.os.SystemProperties");
	            
	            Method get = c.getMethod("get", String.class);
	            postty = (String) get.invoke(c, "ro.config.postty");

	            if(postty==null||postty.isEmpty()==true)
	            {
	            	
    				PosUtils.misPos.setPinLow(MiscUtil.POS_PIN_PWR);
    				PosUtils.misPos.setPinLow(MiscUtil.POS_PIN_PWD); 
	    			
	            	return ;
	            }
	            else if(postty.length()==0)
	            {
	            	PosUtils.misPos.setPinLow(MiscUtil.POS_PIN_PWR);
    				PosUtils.misPos.setPinLow(MiscUtil.POS_PIN_PWD); 
	    			return ;
	            	
	            }
	            else
	            {	
	            	return;
	            }	
	        } catch (Exception e) 
	        {
	        	
	    
	        }
	   }
	    
	   void PowerOnDevice()
	   {
		   	Class<?> c;
	        
	        String postty = null;
	        try {
	        	  
	        	//Log.e(null,"1");
	            c  = Class.forName("android.os.SystemProperties");
	            
	            Method get = c.getMethod("get", String.class);
	            postty = (String) get.invoke(c, "ro.config.postty");

	            if(postty==null||postty.isEmpty()==true)
	            {
	            	PosUtils.misPos = new MiscDevice(MiscUtil.POS_MISC_DEV, MiscUtil.POS_MISC_IO);
	    			PosUtils.misPos.setPinHigh(MiscUtil.POS_PIN_PWR);
	    			PosUtils.misPos.setPinHigh(MiscUtil.POS_PIN_PWD);
	            	return ;
	            }
	            else if(postty.length()==0)
	            {
	            	PosUtils.misPos = new MiscDevice(MiscUtil.POS_MISC_DEV, MiscUtil.POS_MISC_IO);
	    			PosUtils.misPos.setPinHigh(MiscUtil.POS_PIN_PWR);
	    			PosUtils.misPos.setPinHigh(MiscUtil.POS_PIN_PWD);
	            	return ;
	            	
	            }
	            else
	            {	
	            	return;
	            }	
	        } catch (Exception e) 
	        {
	        	
	    
	        }
	   }
	    


}
