package com.example.libtest;

import com.bw.spdev.SysCmd;

import com.odm.misc.MiscUtil;

import android.app.Activity;
import android.app.Dialog;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.view.View;
import android.widget.TextView;

public class MyDialog extends Dialog 
{
	int dialogResult;
	Handler mHandler;
	String stitle;
	private Handler m_handle=new Handler();
	
	public MyDialog(Activity context, String title, String mailName) {
		super(context);
		setOwnerActivity(context);
		
		stitle = title;
		
		onCreate();
		TextView promptLbl = (TextView) findViewById(R.id.textView1);
		promptLbl.setText(mailName);
	}
	void sleep_ms(int ms)
	{
    	try 
		{
	       Thread.currentThread();
	       Thread.sleep(ms);
	    } 
		catch (InterruptedException e)
		{
          e.printStackTrace();
		}  
		
	}
	Runnable mRunnable = new Runnable() 
	{
        public void run() 
        {
        	sleep_ms(300);
        	
        	if(PosUtils.sys.SysGetSpVersion()==null)
				m_handle.postDelayed(this, 10);
			else
			{
				PosUtils.sys.SysUnLockFunction();
				PosUtils.sys.SetCmdSendMaxWT(1000);
				PosUtils.sys.SetRspRecvMaxWT(10000);
				endDialog(5);
			}
					
        }

    };

	public int getDialogResult() {
		return dialogResult;
	}

	public void setDialogResult(int dialogResult) {
		this.dialogResult = dialogResult;
	}

	/** Called when the activity is first created. */

	public void onCreate() {
		setContentView(R.layout.password_dialog);
		setTitle(stitle);
	
		findViewById(R.id.button2).setOnClickListener(
				new android.view.View.OnClickListener() {

					@Override
					public void onClick(View paramView) {
						// endDialog(DialogResult.Cancel);
						endDialog(1);

					}
				});
		findViewById(R.id.btnL2AutoTest).setOnClickListener(
				new android.view.View.OnClickListener() {

					@Override
					public void onClick(View paramView) {
						// endDialog(DialogResult.OK);
						endDialog(5);
					}
				});

		setCanceledOnTouchOutside(false);
		
		findViewById(R.id.button2).setVisibility(4);
		findViewById(R.id.btnL2AutoTest).setVisibility(4);		
		m_handle.postDelayed(mRunnable, 1000);
	}

	public void endDialog(int result) {
		dismiss();
		setDialogResult(result);
		Message m = mHandler.obtainMessage();
		mHandler.sendMessage(m);
	}

	public int showDialog() {
		mHandler = new Handler() {
			@Override
			public void handleMessage(Message mesg) {
				// process incoming messages here
				// super.handleMessage(msg);
				throw new RuntimeException();
			}
		};
		super.show();
		try {
			Looper.getMainLooper().loop();
		} catch (RuntimeException e2) {
		}
		return dialogResult;
	}
}
