package com.example.libtest;

import java.io.UnsupportedEncodingException;


import com.helper.BCDHelper;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;

public class PiccDemo extends Activity 
{
	BCDHelper bcd;
	ScrollView scroview;
	EditText picc_cardtype,picc_cardsn,picc_cardinfo;
	EditText picc_apdu;
	Button btnPiccSend,btnPiccDetect;
	TextView picc_msg,title;
	TextView piccCardType,piccCardInfo,piccCardSn;
	
	int piccflag;
	byte picclogicch;
	ReadThread rth;
	int notgoflag;
	
	private class ReadThread extends Thread 
	 {
			private boolean mStopRunning = false;
			//private AlertDialog show;
			public void stopRunning() {
	            mStopRunning = true;
	        }
			public void startRunning(){
				mStopRunning = false;
			}
			public void run(){
				super.run();
	        	 //int loop=60;
	        	 int flag=0; 
				Log.e("card", "Begin run read thread...");
				while (!mStopRunning) 
				{		        	 
		        	 Log.e(null, "before thread");	 
		        	 while(!mStopRunning)
		        	 {
		        		 
		        		handler1.sendEmptyMessage(9);
		        		 
		        		
		        		if( PosUtils.picc.Detect((byte)0)==0)
		        		{	
		        			flag=1;
		        			break;
		        		}
		        		
		        		Log.e(null,"mode :1 ");
		        		
		        		if( PosUtils.picc.Detect((byte)1)==0)
		        		{	
		        			flag=1;
		        			break;
		        		}
		        		
		        		Log.e(null,"mode :m ");
		        		if( PosUtils.picc.Detect((byte)'m')==0)
		        		{	
		        			flag=1;
		        			break;
		        		}
		        		
		        		
		        		try 
		        		{
		                    Thread.currentThread().sleep(500);
		                } 
		        		catch (InterruptedException e) 
		        		{
		                    e.printStackTrace();
		                }
		                
		        		
		        	 }
		        	 mStopRunning = true;
		        	 handler1.sendEmptyMessage(flag);
		        	 rth.interrupt();
		        	 rth=null;
		         }
			}
		};
	 
	
	 private Handler handler1 =new Handler()
	 {
		   @Override
		   //当有消息发送出来的时候就执行Handler的这个方法
		   public void handleMessage(Message msg)
		   {
		      super.handleMessage(msg);
		      //只要执行到这里就关闭对话框
		      //pd.dismiss();
		      if(msg.what==9)
		      {
		    	 // picc_msg.append("Detecting Picc Card......  \n");
		    	  picc_msg.append(getString(R.string.picc_PlsInsertPicc)+"\n");
					

		      }
		      if(msg.what==0)
		      {   
		    	  picc_msg.append("Didn't detect the Picc Card,timeout! \n");
		    	  picc_msg.scrollTo(0, picc_msg.getHeight());  
		    	 
		      }
		      if(msg.what==1)
		      {
		    	  piccflag=1;
		    	  picclogicch = PosUtils.picc.GetCardChanleFunction();
		    	  
		    	 
		    	  byte atr[] = new byte[100];
		    	  
		    	  picc_msg.append(getString(R.string.picc_DetectedPicc)+"\n");
					
		    	  picc_msg.scrollTo(0, picc_msg.getHeight());
		    	  byte tmp[] = new byte[100];
		    	  tmp[0] = PosUtils.picc.GetCardTypeFunction();
		    	     	  
				try {
					String stmp;
					stmp = new String(tmp, "ISO-8859-1");
					  picc_cardtype.setText(stmp);
					  picc_msg.append(getString(R.string.picc_PiccCardType)+stmp+"\n");
						
			    	  //picc_msg.append("The Card Type is : "+stmp+"\n");
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		    	  
		    	  int snlen =PosUtils.picc.GetCardSNFunction(tmp);
		    	  if(snlen>0)
		    	  {
		    		  String s_sn = bcd.bcdToString(tmp, 0, 2*snlen);
		    		  picc_cardsn.setText(s_sn);
		    		  
		    		  picc_msg.append(getString(R.string.picc_PiccCardType)+s_sn+"\n");
						
		    	  }
		    	  else
		    	  {
		    		  picc_msg.append("Get the card SN Err!  "+"\n");
		    	  }
		    
		    	  
		    	  int infolen = PosUtils.picc.GetCardInfoFunction(tmp);
		    	  
		    	  if(infolen>0)
		    	  {
		    		  String s_info = bcd.bcdToString(tmp, 0, 2*infolen);
		    		  picc_cardinfo.setText(s_info);
		    		  
		    		  picc_msg.append(getString(R.string.picc_PiccCardType)+s_info+"\n");
						
		    	  }
		    	  else
		    	  {
		    		  picc_msg.append("Get the card info Err!  \n");
		    	  }
 
		      }
		      picc_msg.scrollTo(0, picc_msg.getHeight());
		      scroll2Bottom(scroview, picc_msg);
		   }
		};
	
	
	public void onCreate(Bundle savedInstanceState) 
	{
		Log.e(null,"enter the Picc demo activity");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_picc);

		bcd = new BCDHelper();
		
		piccflag = 0;
		picclogicch=0;
		title = (TextView)findViewById(R.id.piccTitle);
		title.setText(R.string.picc_Button);
		scroview = (ScrollView)findViewById(R.id.scroll);
		picc_cardtype =(EditText)findViewById(R.id.editPiccCardType);
		picc_cardsn =(EditText)findViewById(R.id.editPiccCardSn);
		picc_cardinfo =(EditText)findViewById(R.id.editPiccCardInfo);
		picc_apdu =(EditText)findViewById(R.id.editPiccApdu);
		picc_msg =(TextView)findViewById(R.id.PiccMsgView);
		
		btnPiccSend=(Button)findViewById(R.id.btnPiccSend);
		btnPiccDetect=(Button)findViewById(R.id.btnPiccDetectCard);
		btnPiccSend.setText(R.string.picc_SendApdu);
		btnPiccDetect.setText(R.string.picc_StartDetect);
		piccCardType=(TextView)findViewById(R.id.piccCardType);
		piccCardInfo=(TextView)findViewById(R.id.piccCardInfo);
		piccCardSn=(TextView)findViewById(R.id.piccCardSn);
		
		piccCardType.setText(R.string.picc_PiccCardType);
		piccCardInfo.setText(R.string.picc_PiccCardInfo);
		piccCardSn.setText(R.string.picc_PiccCardSn);
		
		
		ModuleButton listener = new ModuleButton();
		btnPiccSend.setOnClickListener(listener);
		btnPiccDetect.setOnClickListener(listener);	
		
		picc_apdu.setText("00A40000023F00");
		
	}
    public static void scroll2Bottom(final ScrollView scroll, final View inner) 
    {  
        Handler handler = new Handler();  
        handler.post(new Runnable() {  
  
            @Override  
            public void run() {  
                // TODO Auto-generated method stub   
                if (scroll == null || inner == null) {  
                    return;  
                }  
                // 内层高度超过外层   
                int offset = inner.getMeasuredHeight()  
                        - scroll.getMeasuredHeight();  
                if (offset < 0) {  
                    
                    offset = 0;  
                }  
                scroll.scrollTo(0, offset);  
            }  
        });  
    } 

    public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		Log.e(null,"enter the keydown process");
	    if(keyCode == KeyEvent.KEYCODE_BACK) 
	    { //监控/拦截/屏蔽返回键
	    	if(rth!=null)
	    		rth.stopRunning();	
	    	
	    	PosUtils.picc.Close();
	    	PiccDemo.this.finish();
	    	
	    } 
	    else if(keyCode == KeyEvent.KEYCODE_MENU) 
	    {
	        //监控/拦截菜单键
	    } 
	    else if(keyCode == KeyEvent.KEYCODE_HOME) 
	    {
	        //由于Home键为系统键，此处不能捕获，需要重写onAttachedToWindow()
	    }
	    return super.onKeyDown(keyCode, event);
	}
    
    
    
	class ModuleButton implements OnClickListener
	{
		int ret ;
		public void onClick(View v)
		{
			switch(v.getId())
			{
			
			case R.id.btnPiccDetectCard:
				
				picc_cardsn.setText("");
				picc_cardtype.setText("");
				picc_cardinfo.setText("");
				
				if(piccflag ==1)
				{
					PosUtils.picc.Remove((byte)'h', (byte)picclogicch);
					piccflag=0;
				}
				if(rth!=null)
				{
					rth.mStopRunning = true;	
				}
				if(rth==null)
					rth = new ReadThread();
				rth.mStopRunning = true;	
					
				ret =PosUtils.picc.Open();
				
				if(ret == -1)
				{			
					picc_msg.append(getString(R.string.picc_OpenModelFail)+"\n");
					rth.mStopRunning = true;
					notgoflag=1;
					Log.e(null, "ini err");
				}
				else
				{
					picc_msg.append(getString(R.string.picc_OpenModelOk)+"\n");
					notgoflag=0;
					rth.mStopRunning = false;
					Log.e(null, "ini ok");
				}
				
				rth.start();		

				if(notgoflag == 1)
				{
					//picc_msg.append("SP对命令没有响应,没有返回0x06\n");
				}
			
				break;

			case R.id.btnPiccSend:
				String str=picc_apdu.getText().toString();
				
				if(str.length()%2!=0||str.length()<8)
				{
					picc_msg.append(getString(R.string.picc_ApduLenError)+"\n");
					
					picc_msg.scrollTo(0, picc_msg.getHeight());
					break;
				}	
				
				byte []pCmd = new byte[300];
				byte []pRsp = new byte[300];
				byte []pSW = new byte[3];
				
				picc_msg.append(str+"\n");
				pCmd = bcd.StrToBCD(str);
				ret =PosUtils.picc.ApduTransmit(pCmd, str.length()/2, pRsp, pSW);
				if(ret<0)
				{
					picc_msg.append(getString(R.string.picc_ApduErr)+"\n");
					
					
				}	
				else
				{
					if(ret > 0)
					{
						String strrsp = bcd.bcdToString(pRsp, 0, ret);
						picc_msg.append(strrsp+"\n");
						Log.e("iccdemo",strrsp);
						
					}
					String strsw =  bcd.bcdToString(pSW, 0, 4);
					picc_msg.append(strsw+"\n");		
					Log.e("iccdemo",strsw);
				}
				picc_msg.scrollTo(0, picc_msg.getHeight());

				break;
			}
			   scroll2Bottom(scroview, picc_msg);

		}
	}

}
